TYPO3 Core - Bug #64449
Epic # 65429 (Closed): Speed up for Fluid ViewHelpers by usage of Compilablelnterface

f:switch very slow since it does not implement Compilablelnterface interface
2015-01-23 11:43 - Christian Weiske

Status: Closed Start date: 2015-01-23
Priority: Should have Due date:

Assignee: % Done: 100%
Category: Fluid Estimated time: 0.00 hour
Target version: 7.2 (Frontend)

TYPOS3 Version: 7 Complexity:

PHP Version: Is Regression: No

Tags: Sprint Focus:

Description

The Fluid SwitchViewHelper (<f:switch>) does not implement Compilablelnterface. This prevents the TemplateParser from caching it,
making template rendering unbearably slow.

<f:if> on the other hand does implement the interface (through AbstractConditionViewHelper) and gets cached properly.

<f:switch> should be cached!

Related issues:

Related to TYPO3 Core - Task #64521: Merge performance improvement from TYPOS3... Closed 2015-01-26
Related to TYPO3 Core - Task #64546: Add Compilablelnterface to a couple of V... Closed 2015-01-27
Is duplicate of TYPOS3 Core - Task #66718: Make SwitchViewHelper Compileable Closed 2015-05-01
History

#1 - 2015-01-23 12:08 - Mathias Schreiber

- Target version set to 7.2 (Frontend)

#2 - 2015-01-26 08:40 - Christian Weiske

Btw, simply adding an "implements ..." line to the class declaration leads to bugs in the output.

#3 - 2015-01-26 12:42 - Christian Kuhn

Yes. This is not only this specific view helper, there are much more. I'm currently working on a fresh backport from TYPO3.fluid that has much more
compilable interfaces implemented already, you can expect a patch in this area soon.

#4 - 2015-01-26 12:53 - Christian Kuhn

if backport is done, a couple of other view helpers that did not yet have been fixed in fluid upstream will be changed for cms core locally. the
performance boost is just too high to wait for upstream at this point ... give me some time and expect this issue to be fixed soon. i'll ping you for
reviews if you find the time, Christian.

#5 - 2015-03-01 12:45 - Anja Leichsenring
- Parent task set to #65429

#6 - 2015-03-03 10:16 - Bastian Waidelich
Hi,

that is a problem indeed. The actual issue is not that the ViewHelper itself is not compilable, but that it also implements the
{ChildNodeAccessInterface}} which - in combination - leads to the whole template file not being compiled. (see
https://jira.typo3.org/browse/FLOW-224).

BTW: The same is true when using widgets, but in those cases the issue is probably very hard to solve unfortunately (see
https://jira.typo3.org/browse/FLOW-196).

#7 - 2015-05-03 12:50 - Christian Kuhn

- Status changed from New to Resolved
This was resolved with #66718

#8 - 2015-05-03 12:50 - Christian Kuhn
- % Done changed from 0 to 100

#9 - 2017-10-19 21:25 - Riccardo De Contardi

- Status changed from Resolved to Closed
